//=================================//
//latch case1
module module1_latch1(
    input       data,
    input       en ,
    output reg  q) ;

    always @(*) begin
        if (en) q = data ;
    end

endmodule

//way1 to modify
module module1_latch1_m1(
    input       data,
    input       en ,
    output reg  q) ;

    always @(*) begin
        if (en) q = data ;
        else    q = 1'b0 ;
    end

endmodule

//way2 to modify
module module1_latch1_m2(
    input       data,
    input       en ,
    output reg  q) ;

    always @(*) begin
        q = 1'b0 ;
        if (en) q = data ;
    end

endmodule

//flip-flop
module module1_ff(
    input       clk ,
    input       data,
    input       en ,
    output reg  q) ;

    always @(posedge clk) begin
        if (en) q <= data ;
    end

endmodule // module1_ff

// assignment is not complete
module module1_latch11(
    input       data1,
    input       data2,
    input       en ,
    output reg  q1 ,
    output reg  q2) ;

    always @(*) begin
        if (en)   q1 = data1 ;
        else      q2 = data2 ;
    end

endmodule // module1_latch11

//way to modify: assignment is not complete
module module1_latch11_m1(
    input       data1,
    input       data2,
    input       en ,
    output reg  q1 ,
    output reg  q2) ;

    always @(*) begin
        //q1 = 0; q2 = 0 ;
        if (en)  begin
            q1 = data1 ;
            q2 = 1'b0 ;
        end
        else begin
            q1 = 1'b0 ;
            q2 = data2 ;
        end
    end

endmodule // module1_latch11
